package com.sagacloud.extend.customfunction;

import com.sagacloud.util.compute_engine.core.AnnotationDescription;
import com.sagacloud.util.compute_engine.core.ICustomFunction;

import java.util.Iterator;
import java.util.Map;

@AnnotationDescription(value = "custom_function")
public class ImplCustomFunction_add implements ICustomFunction {
    @Override
    public String GetName() {
        return "custom_add";
    }

    @Override
    public double Compute(Map<String, Double> inputMap) {
        double result = 0.0;
        Iterator<String> keyIter = inputMap.keySet().iterator();
        while (keyIter.hasNext()) {
            String key = keyIter.next();
            Double value = inputMap.get(key);
            if (value != null) {
                result += value;
            }
        }
        return result;
    }
}
