package com.sagacloud.util.compute_engine.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class QueryUtil {

    public static void ClearTable(String database_name, String table_name, boolean is_clear) throws Exception {
        JSONObject Criteria = new JSONObject();
        JSONObject wrapperObject = new JSONObject();
        if (is_clear) {
            wrapperObject.put("QueryType", "table_clear");
        } else {
            wrapperObject.put("QueryType", "delete");
        }
        wrapperObject.put("Criteria", Criteria);
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", table_name);
        HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
    }

    public static void insert(String database_name, String table_name, JSONObject InsertObject) throws Exception {
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "insert");
        wrapperObject.put("InsertObject", InsertObject);
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", table_name);
        log.info(wrapperObject.toJSONString());
        HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
    }

    public static void batch_insert(String database_name, String table_name, JSONArray InsertObjects) throws Exception {
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "batch_insert");
        wrapperObject.put("InsertObjects", InsertObjects);
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", table_name);
        log.info(wrapperObject.toJSONString());
        HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
    }

    public static JSONArray select(String database_name, String table_name, JSONObject Criteria) throws Exception {
        JSONArray resultContent = select(database_name, table_name, Criteria, null, null);
        return resultContent;
    }

    public static JSONArray select(String database_name, String table_name, JSONObject Criteria, JSONArray OrderBy,
                                   JSONObject Limit) throws Exception {
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "select");
        wrapperObject.put("Criteria", Criteria);
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", table_name);
        if (OrderBy != null) {
            wrapperObject.put("OrderBy", OrderBy);
        }
        if (Limit != null) {
            wrapperObject.put("Limit", Limit);
        }
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        JSONArray resultContent = (JSONArray) queryResult.get("Content");

        return resultContent;
    }

    public static Long delete(String database_name, String table_name, JSONObject Criteria) throws Exception {
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "delete");
        wrapperObject.put("Criteria", Criteria);
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", table_name);
        log.info(wrapperObject.toJSONString());
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        Long Count = (Long) queryResult.get("Count");

        return Count;
    }

    public static void update(String database_name, String table_name, JSONObject Criteria, JSONObject Set) throws Exception {
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "update");
        wrapperObject.put("Criteria", Criteria);
        wrapperObject.put("Set", Set);
        wrapperObject.put("Database", database_name);
        wrapperObject.put("Datatable", table_name);
        log.info(wrapperObject.toJSONString());
        HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
    }

    public static boolean database_exist(String database_name) throws Exception {
        boolean result = false;
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "database_list");
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        JSONArray resultContent = (JSONArray) queryResult.get("Content");
        for (int i = 0; i < resultContent.size(); i++) {
            String item = (String) resultContent.get(i);
            if (item.equals(database_name)) {
                result = true;
                break;
            }
        }
        return result;
    }

    public static boolean table_exist(String database_name, String table_name) throws Exception {
        boolean result = false;
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "table_list");
        wrapperObject.put("Database", database_name);
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        JSONArray resultContent = (JSONArray) queryResult.get("Content");
        for (int ii = 0; ii < resultContent.size(); ii++) {
            String item = (String) resultContent.get(ii);
            if (item.equals(table_name)) {
                result = true;
                break;
            }
        }
        return result;
    }

    public static JSONObject OrderByItem(String Column, boolean Asc) {
        JSONObject result = new JSONObject();
        result.put("Column", Column);
        result.put("Asc", Asc);
        return result;
    }
}
