package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import com.zillion.database.agent.ZillionAgent;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.Date;
@Slf4j
public class modify_time_period_Thread extends Thread {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

    ZillionAgent agent;
    String database_name;

    public modify_time_period_Thread(String database_name) {

        this.database_name = database_name;
    }

    @Override
    public void run() {
        while (true) {
            JSONObject item = modify_time_period.Pop();
            if (item == null) {
                break;
            }

            String building = (String) item.get("building");
            String meter = (String) item.get("meter");
            Long funcid = (Long) item.get("funcid");
            try {
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    JSONObject SetInner = new JSONObject();
                    SetInner.put("collect_cycle", "10min");
                    QueryUtil.update(database_name, "dy_pointlist", CriteriaInner, SetInner);
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_0_metercomputetime", CriteriaInner);
                    if (resultContentInner != null && resultContentInner.size() > 0) {
                        JSONObject itemInner = (JSONObject) resultContentInner.get(0);
                        String next_data_time = (String) itemInner.get("next_data_time");
                        Date date_old = sdf.parse(next_data_time);
                        Date date_new = new Date(date_old.getTime() / (1000L * 60 * 10) * (1000L * 60 * 10));
                        if (date_new.getTime() != date_old.getTime()) {
                            JSONObject SetInner = new JSONObject();
                            SetInner.put("next_data_time", sdf.format(date_new));
                            QueryUtil.update(database_name, "fjd_0_metercomputetime", CriteriaInner, SetInner);
                        }
                    }
                }
                {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    CriteriaInner.put("time_period", "15min");
                    JSONObject rangeInner = new JSONObject();
                    rangeInner.put("$gte", "20171101000000");
                    rangeInner.put("$lt", "20180101000000");
                    CriteriaInner.put("data_time", rangeInner);
                    JSONArray resultContentInner = QueryUtil.select(database_name, "fjd_0_near", CriteriaInner);
                    JSONArray InsertObjects = new JSONArray();
                    for (int ii = 0; ii < resultContentInner.size(); ii++) {
                        JSONObject itemInner = (JSONObject) resultContentInner.get(ii);
                        try {
                            Date data_time = sdf.parse((String) itemInner.get("data_time"));
                            Double data_value = (Double) itemInner.get("data_value");
                            Date data_time1 = null;
                            Double data_value1 = null;
                            if (ii > 0) {
                                JSONObject itemInnerLast = (JSONObject) resultContentInner.get(ii - 1);
                                Date data_timeLast = sdf.parse((String) itemInnerLast.get("data_time"));
                                Double data_valueLast = (Double) itemInnerLast.get("data_value");
                                if (data_time.getTime() - data_timeLast.getTime() == 1000L * 60 * 15) {
                                    data_time1 = data_timeLast;
                                    data_value1 = data_valueLast;
                                }
                            }

                            if (data_time1 != null) {
                                Date data_time_10min;
                                Double data_value_10min;
                                if (data_time.getTime() % (1000L * 60 * 10) == 0) {
                                    data_time_10min = new Date(data_time.getTime() - (1000L * 60 * 10));
                                    data_value_10min = (data_value * 1.0 + data_value1 * 2.0) / (1.0 + 2.0);
                                } else {
                                    data_time_10min = new Date(data_time1.getTime() + (1000L * 60 * 10));
                                    data_value_10min = (data_value * 2.0 + data_value1 * 1.0) / (2.0 + 1.0);
                                }

                                JSONObject InsertObject = new JSONObject();
                                InsertObject.put("building", building);
                                InsertObject.put("meter", meter);
                                InsertObject.put("funcid", funcid);
                                InsertObject.put("time_period", "10min");
                                InsertObject.put("data_time", sdf.format(data_time_10min));
                                InsertObject.put("data_value", data_value_10min);
                                InsertObject.put("data_flag", 0L);
                                InsertObjects.add(InsertObject);
                            }
                            if (data_time.getTime() % (1000L * 60 * 10) == 0) {
                                JSONObject InsertObject = new JSONObject();
                                InsertObject.put("building", building);
                                InsertObject.put("meter", meter);
                                InsertObject.put("funcid", funcid);
                                InsertObject.put("time_period", "10min");
                                InsertObject.put("data_time", itemInner.get("data_time"));
                                InsertObject.put("data_value", itemInner.get("data_value"));
                                InsertObject.put("data_flag", 0L);
                                InsertObjects.add(InsertObject);
                            }
                        } catch (Exception e) {
                            log.error(e.getMessage(),e);
                        }
                    }
                    if (InsertObjects.size() > 0) {
                        QueryUtil.batch_insert(database_name, "fjd_0_near", InsertObjects);
                    }
                    QueryUtil.delete(database_name, "fjd_0_near", CriteriaInner);
                }
            } catch (Exception e) {
                log.error(e.getMessage(),e);
            }
        }
    }
}
