package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.zillion.util.table.ZillionTableColumn;
import com.zillion.util.table.ZillionTableColumnEnum;
import com.zillion.util.table.ZillionTableSchema;

import java.util.ArrayList;
import java.util.List;

public class set_dy_pointlist {

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        String table_name = "dy_pointlist";
        ZillionTableSchema schema = HBaseSaveManagerRepository.randomZillionAgent().container.repositoryMap.get(ConstantCE.database_name).GetTable(table_name);

        JSONObject Criteria = new JSONObject();
        Criteria.put("building", "1101080001");
        JSONObject wrapperObject = new JSONObject();
        wrapperObject.put("QueryType", "select");
        wrapperObject.put("Criteria", Criteria);
        wrapperObject.put("Database", ConstantCE.database_name);
        wrapperObject.put("Datatable", table_name);
        JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
        JSONArray resultContent = (JSONArray) queryResult.get("Content");
        MyPrint(schema, resultContent);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            String building = (String) item.get("building");
            String meter = (String) item.get("meter");
            Long funcid = (Long) item.get("funcid");
            String data_type = (String) item.get("data_type");
            JSONObject CriteriaInner = new JSONObject();
            CriteriaInner.put("building", building);
            CriteriaInner.put("meter", meter);
            CriteriaInner.put("funcid", funcid);
            {
                JSONObject SetInner = new JSONObject();
                if ("Acc".equals(data_type)) {
                    SetInner.put("collect_cycle", "15min");
                } else {
                    if (meter.charAt(0) >= 'A' && meter.charAt(0) <= 'Z') {
                        SetInner.put("collect_cycle", "5min");
                    } else {
                        SetInner.put("collect_cycle", "1min");
                    }
                }

                if (SetInner.size() > 0) {
                    JSONObject wrapperObjectInner = new JSONObject();
                    wrapperObjectInner.put("QueryType", "update");
                    wrapperObjectInner.put("Criteria", CriteriaInner);
                    wrapperObjectInner.put("Set", SetInner);
                    wrapperObjectInner.put("Database", ConstantCE.database_name);
                    wrapperObjectInner.put("Datatable", table_name);
                    HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObjectInner);
                }
            }
        }


        System.out.println();
    }

    static void MyPrint(ZillionTableSchema schema, JSONArray resultContent) {
        List<String> columnList = new ArrayList<String>();
        for (String column : schema.Key) {
            columnList.add(column);
        }
        for (String column : schema.OtherColumn) {
            columnList.add(column);
        }

        for (String column : columnList) {
            System.out.printf("%20s", column);
            System.out.print("\t");
        }
        System.out.println();
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject item = (JSONObject) resultContent.get(i);
            for (String column : columnList) {
                ZillionTableColumn column_schema = schema.ColumnMap.get(column);
                if (column_schema.Type == ZillionTableColumnEnum.BOOLEAN) {
                    System.out.printf("%20s", ((Boolean) item.get(column)) ? "true" : "false");
                } else if (column_schema.Type == ZillionTableColumnEnum.LONG) {
                    System.out.printf("%20d", (Long) item.get(column));
                } else if (column_schema.Type == ZillionTableColumnEnum.DOUBLE) {
                    System.out.printf("%20.2f", (Double) item.get(column));
                } else if (column_schema.Type == ZillionTableColumnEnum.STRING) {
                    System.out.printf("%20s", (String) item.get(column));
                }
                System.out.print("\t");
            }
            System.out.println();
        }
    }
}
