package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.Date;

@Slf4j
public class stat_fjd_delay_index {

    public static void main(String[] args) throws Exception {
        if (HBaseSaveManagerRepository.randomZillionAgent() == null) {
            HBaseSaveManagerRepository.init(1);
        }

        String database_name = ConstantCE.database_name;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        long interval = 1000L * 60 * 15;

        for (int index_cycle = 0; index_cycle < Integer.MAX_VALUE; index_cycle++) {
            Thread.sleep(1000L * 10);

            Date currentTime = new Date();
            Date next_time = new Date(currentTime.getTime() / interval * interval + interval);

            int valid_count = 0;
            double valid_avglag = 0.0;
            int building_valid_count = 0;
            double building_valid_avglag = 0.0;
            JSONObject Criteria = new JSONObject();
            JSONArray resultContent = QueryUtil.select(database_name, "fjd_0_metercomputetime", Criteria);
            String tmp_building = null;
            int tmp_valid_count = 0;
            long tmp_valid_bestlag = 0;
            for (int i = 0; i < resultContent.size(); i++) {
                JSONObject item = (JSONObject) resultContent.get(i);
                String building = (String) item.get("building");
                String meter = (String) item.get("meter");
                Long funcid = (Long) item.get("funcid");
                Date next_data_time = sdf.parse((String) item.get("next_data_time"));

                if (i == 0) {
                    tmp_building = building;
                    tmp_valid_count = 0;
                    tmp_valid_bestlag = 0;
                }
                if (tmp_building != null && !tmp_building.equals(building)) {
                    if (tmp_valid_count > 0) {
                        building_valid_count++;
                        building_valid_avglag += tmp_valid_bestlag;
                        // log.warn(tmp_building + "\t" + tmp_valid_bestlag);
                    }
                    tmp_building = building;
                    tmp_valid_count = 0;
                    tmp_valid_bestlag = 0;
                }

                long item_lag = (next_time.getTime() - next_data_time.getTime()) / interval;
                if (funcid == 0 && item_lag <= 96) {
                    valid_count++;
                    valid_avglag += item_lag;

                    tmp_valid_count++;
                    if (tmp_valid_count == 0 || tmp_valid_bestlag > item_lag) {
                        tmp_valid_bestlag = item_lag;
                    }
                }

                if (i == resultContent.size() - 1) {
                    if (tmp_valid_count > 0) {
                        building_valid_count++;
                        building_valid_avglag += tmp_valid_bestlag;
                        // log.warn(tmp_building + "\t" + tmp_valid_bestlag);
                    }
                }
            }
            log.warn(valid_count + "\t" + (valid_avglag / valid_count) + "\t" + "finish");
            log.warn(building_valid_count + "\t" + (building_valid_avglag / building_valid_count) + "\t" + "finish");
        }


        System.out.println();
    }
}
